diff --git a/app/test/test_atomic.c b/app/test/test_atomic.c
index f10f555af8b4..7dfa10a70102 100644
--- a/app/test/test_atomic.c
+++ b/app/test/test_atomic.c
@@ -88,7 +88,7 @@
  *
  *   - Invoke ``test_atomic_exchange`` on each lcore.  Before doing
  *     anything else, the cores wait for a synchronization event.
- *     Each core then does the follwoing for N iterations:
+ *     Each core then does the following for N iterations:
  *
  *       Generate a new token with a data integrity check
  *       Exchange the new token for previously generated token
diff --git a/app/test/test_barrier.c b/app/test/test_barrier.c
index c27f8a0742f2..8fa93c00329a 100644
--- a/app/test/test_barrier.c
+++ b/app/test/test_barrier.c
@@ -66,7 +66,7 @@ struct plock_test {
 struct lcore_plock_test {
 	struct plock_test *pt[2]; /* shared, lock-protected data */
 	uint64_t sum[2];          /* local copy of the shared data */
-	uint64_t iter;            /* number of iterations to perfom */
+	uint64_t iter;            /* number of iterations to perform */
 	uint32_t lc;              /* given lcore id */
 };
 
diff --git a/app/test/test_bpf.c b/app/test/test_bpf.c
index 527c06b80708..cf6e022f7a92 100644
--- a/app/test/test_bpf.c
+++ b/app/test/test_bpf.c
@@ -2391,7 +2391,7 @@ static const struct ebpf_insn test_call5_prog[] = {
 	},
 };
 
-/* String comparision impelementation, return 0 if equal else difference */
+/* String comparison implementation, return 0 if equal else difference */
 static uint32_t
 dummy_func5(const char *s1, const char *s2)
 {
diff --git a/app/test/test_compressdev.c b/app/test/test_compressdev.c
index 0571c17ecb8d..a7d04c02c6dd 100644
--- a/app/test/test_compressdev.c
+++ b/app/test/test_compressdev.c
@@ -2035,7 +2035,7 @@ test_deflate_comp_decomp(const struct interim_data_params *int_data,
 	test_priv_data.all_decomp_data = &all_decomp_data;
 	test_priv_data.decomp_produced_data_size = &decomp_produced_data_size;
 
-	test_priv_data.num_priv_xforms = 0; /* it's used for deompression only */
+	test_priv_data.num_priv_xforms = 0; /* it's used for decompression only */
 
 	capa = rte_compressdev_capability_get(0, RTE_COMP_ALGO_DEFLATE);
 	if (capa == NULL) {
diff --git a/app/test/test_func_reentrancy.c b/app/test/test_func_reentrancy.c
index 231c99a9ebc5..69ff421b1824 100644
--- a/app/test/test_func_reentrancy.c
+++ b/app/test/test_func_reentrancy.c
@@ -242,7 +242,7 @@ hash_create_free(__rte_unused void *arg)
 			rte_atomic32_inc(&obj_count);
 	}
 
-	/* create mutiple times simultaneously */
+	/* create multiple times simultaneously */
 	for (i = 0; i < MAX_ITER_MULTI; i++) {
 		snprintf(hash_name, sizeof(hash_name), "fr_test_%d_%d", lcore_self, i);
 		hash_params.name = hash_name;
@@ -306,7 +306,7 @@ fbk_create_free(__rte_unused void *arg)
 			rte_atomic32_inc(&obj_count);
 	}
 
-	/* create mutiple fbk tables simultaneously */
+	/* create multiple fbk tables simultaneously */
 	for (i = 0; i < MAX_ITER_MULTI; i++) {
 		snprintf(fbk_name, sizeof(fbk_name), "fr_test_%d_%d", lcore_self, i);
 		fbk_params.name = fbk_name;
@@ -368,7 +368,7 @@ lpm_create_free(__rte_unused void *arg)
 			rte_atomic32_inc(&obj_count);
 	}
 
-	/* create mutiple fbk tables simultaneously */
+	/* create multiple fbk tables simultaneously */
 	for (i = 0; i < MAX_LPM_ITER_TIMES; i++) {
 		snprintf(lpm_name, sizeof(lpm_name), "fr_test_%d_%d", lcore_self, i);
 		lpm = rte_lpm_create(lpm_name, SOCKET_ID_ANY, &config);
diff --git a/app/test/test_ipsec.c b/app/test/test_ipsec.c
index fb90130ae23b..f421ce45795b 100644
--- a/app/test/test_ipsec.c
+++ b/app/test/test_ipsec.c
@@ -654,7 +654,7 @@ create_crypto_session(struct ipsec_unitest_params *ut,
 	if (s == NULL)
 		return -ENOMEM;
 
-	/* initiliaze SA crypto session for device */
+	/* initialize SA crypto session for device */
 	rc = rte_cryptodev_sym_session_init(dev_id, s,
 			ut->crypto_xforms, qp->mp_session_private);
 	if (rc == 0) {
diff --git a/app/test/test_link_bonding.c b/app/test/test_link_bonding.c
index 8a5c8310a8b4..fd246725096c 100644
--- a/app/test/test_link_bonding.c
+++ b/app/test/test_link_bonding.c
@@ -3041,7 +3041,7 @@ test_balance_tx_burst_slave_tx_fail(void)
 	first_tx_fail_idx = TEST_BAL_SLAVE_TX_FAIL_BURST_SIZE_1 -
 			TEST_BAL_SLAVE_TX_FAIL_PACKETS_COUNT;
 
-	/* copy mbuf referneces for expected transmission failures */
+	/* copy mbuf references for expected transmission failures */
 	for (i = 0; i < TEST_BAL_SLAVE_TX_FAIL_PACKETS_COUNT; i++)
 		expected_fail_pkts[i] = pkts_burst_1[i + first_tx_fail_idx];
 
diff --git a/app/test/test_lpm.c b/app/test/test_lpm.c
index 556f5a67baf1..37b460af3a96 100644
--- a/app/test/test_lpm.c
+++ b/app/test/test_lpm.c
@@ -179,7 +179,7 @@ test3(void)
 	status = rte_lpm_add(NULL, ip, depth, next_hop);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -217,7 +217,7 @@ test4(void)
 	status = rte_lpm_delete(NULL, ip, depth);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -255,7 +255,7 @@ test5(void)
 	status = rte_lpm_lookup(NULL, ip, &next_hop_return);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
diff --git a/app/test/test_lpm6.c b/app/test/test_lpm6.c
index 0d664546fa47..17221f992aee 100644
--- a/app/test/test_lpm6.c
+++ b/app/test/test_lpm6.c
@@ -261,7 +261,7 @@ test4(void)
 	status = rte_lpm6_add(NULL, ip, depth, next_hop);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm6_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -299,7 +299,7 @@ test5(void)
 	status = rte_lpm6_delete(NULL, ip, depth);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm6_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -337,7 +337,7 @@ test6(void)
 	status = rte_lpm6_lookup(NULL, ip, &next_hop_return);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm6_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -375,7 +375,7 @@ test7(void)
 	status = rte_lpm6_lookup_bulk_func(NULL, ip, next_hop_return, 10);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm6_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -413,7 +413,7 @@ test8(void)
 	status = rte_lpm6_delete_bulk_func(NULL, ip, depth, 10);
 	TEST_LPM_ASSERT(status < 0);
 
-	/*Create vaild lpm to use in rest of test. */
+	/*Create valid lpm to use in rest of test. */
 	lpm = rte_lpm6_create(__func__, SOCKET_ID_ANY, &config);
 	TEST_LPM_ASSERT(lpm != NULL);
 
@@ -433,7 +433,7 @@ test8(void)
 /*
  * Call add, lookup and delete for a single rule with depth < 24.
  * Check all the combinations for the first three bytes that result in a hit.
- * Delete the rule and check that the same test returs a miss.
+ * Delete the rule and check that the same test returns a miss.
  */
 int32_t
 test9(void)
@@ -1738,7 +1738,7 @@ test27(void)
  * Call add, lookup and delete for a single rule with maximum 21bit next_hop
  * size.
  * Check that next_hop returned from lookup is equal to provisioned value.
- * Delete the rule and check that the same test returs a miss.
+ * Delete the rule and check that the same test returns a miss.
  */
 int32_t
 test28(void)
diff --git a/app/test/test_malloc.c b/app/test/test_malloc.c
index afff0de9f05a..6d9249f831be 100644
--- a/app/test/test_malloc.c
+++ b/app/test/test_malloc.c
@@ -603,7 +603,7 @@ test_realloc_numa(void)
 		}
 	}
 
-	/* Print warnign if only a single socket, but don't fail the test */
+	/* Print warning if only a single socket, but don't fail the test */
 	if (socket_count < 2)
 		printf("WARNING: realloc_socket test needs memory on multiple sockets!\n");
 
@@ -971,7 +971,7 @@ test_alloc_socket(void)
 		}
 	}
 
-	/* Print warnign if only a single socket, but don't fail the test */
+	/* Print warning if only a single socket, but don't fail the test */
 	if (socket_count < 2) {
 		printf("WARNING: alloc_socket test needs memory on multiple sockets!\n");
 	}
diff --git a/app/test/test_mbuf.c b/app/test/test_mbuf.c
index 9a248dfaea70..167c0938b633 100644
--- a/app/test/test_mbuf.c
+++ b/app/test/test_mbuf.c
@@ -1148,7 +1148,7 @@ test_refcnt_mbuf(void)
 
 	rte_eal_mp_wait_lcore();
 
-	/* check that we porcessed all references */
+	/* check that we processed all references */
 	tref = 0;
 	main_lcore = rte_get_main_lcore();
 
diff --git a/app/test/test_mempool.c b/app/test/test_mempool.c
index 7675a3e605fb..5b559a04d142 100644
--- a/app/test/test_mempool.c
+++ b/app/test/test_mempool.c
@@ -628,7 +628,7 @@ test_mempool(void)
 	if (test_mempool_basic_ex(mp_nocache) < 0)
 		GOTO_ERR(ret, err);
 
-	/* mempool operation test based on single producer and single comsumer */
+	/* mempool operation test based on single producer and single consumer */
 	if (test_mempool_sp_sc() < 0)
 		GOTO_ERR(ret, err);
 
diff --git a/app/test/test_mempool_perf.c b/app/test/test_mempool_perf.c
index 8f629736e8fd..87ad25136796 100644
--- a/app/test/test_mempool_perf.c
+++ b/app/test/test_mempool_perf.c
@@ -88,7 +88,7 @@ static uint32_t synchro;
 static unsigned n_get_bulk;
 static unsigned n_put_bulk;
 
-/* number of objects retrived from mempool before putting them back */
+/* number of objects retrieved from mempool before putting them back */
 static unsigned n_keep;
 
 /* number of enqueues / dequeues */
diff --git a/app/test/test_meter.c b/app/test/test_meter.c
index f6fe6494ab63..15d5a4839b4b 100644
--- a/app/test/test_meter.c
+++ b/app/test/test_meter.c
@@ -444,7 +444,7 @@ tm_test_srtcm_color_aware_check(void)
 	  * if using blind check
 	  */
 
-	/* previouly have a green, test points should keep unchanged */
+	/* previously have a green, test points should keep unchanged */
 	in[0] = in[1] = in[2] = in[3] = RTE_COLOR_GREEN;
 	out[0] = RTE_COLOR_GREEN;
 	out[1] = RTE_COLOR_YELLOW;
@@ -551,7 +551,7 @@ tm_test_trtcm_color_aware_check(void)
 	  * if using blind check
 	  */
 
-	/* previouly have a green, test points should keep unchanged */
+	/* previously have a green, test points should keep unchanged */
 	in[0] = in[1] = in[2] = in[3] = RTE_COLOR_GREEN;
 	out[0] = RTE_COLOR_GREEN;
 	out[1] = RTE_COLOR_YELLOW;
@@ -648,7 +648,7 @@ tm_test_trtcm_rfc4115_color_aware_check(void)
 	  * if using blind check
 	  */
 
-	/* previouly have a green, test points should keep unchanged */
+	/* previously have a green, test points should keep unchanged */
 	in[0] = in[1] = in[2] = in[3] = RTE_COLOR_GREEN;
 	out[0] = RTE_COLOR_GREEN;
 	out[1] = RTE_COLOR_YELLOW;
diff --git a/app/test/test_pmd_perf.c b/app/test/test_pmd_perf.c
index 3a248d512c4a..1ef844ba7568 100644
--- a/app/test/test_pmd_perf.c
+++ b/app/test/test_pmd_perf.c
@@ -753,7 +753,7 @@ test_pmd_perf(void)
 				"rte_eth_dev_start: err=%d, port=%d\n",
 				ret, portid);
 
-		/* always eanble promiscuous */
+		/* always enable promiscuous */
 		ret = rte_eth_promiscuous_enable(portid);
 		if (ret != 0)
 			rte_exit(EXIT_FAILURE,
diff --git a/app/test/test_timer.c b/app/test/test_timer.c
index a10b2fe9daf4..631b737d169d 100644
--- a/app/test/test_timer.c
+++ b/app/test/test_timer.c
@@ -432,7 +432,7 @@ timer_basic_cb(struct rte_timer *tim, void *arg)
 		return;
 	}
 
-	/* Explicitelly stop timer 0. Once stop() called, we can even
+	/* Explicitly stop timer 0. Once stop() called, we can even
 	 * erase the content of the structure: it is not referenced
 	 * anymore by any code (in case of dynamic structure, it can
 	 * be freed) */